#ifndef __CONFIG_H_
#define __CONFIG_H_

#if !defined(__C251__) && !defined(__C51__)
#include "../debug.h"
#endif

// ٷͷļ
#include "STC32F.h"

// Cִ֧
#include "intrins.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

// ܶ
#define u8 unsigned char
#define u16 unsigned int
#define u32 unsigned long

#define MAIN_Fosc 52000000UL // ʱ
#define Baudrate (65536UL - (MAIN_Fosc / 4) / 200000UL)

#define MOSI P13
#define SCLK P15
#define MISO P14
void ICacheOff(void); // رcacheٻ
void ICacheOn(void);  // cacheٻ


#if (MAIN_Fosc < 30000000UL)
#define WAIT 0x00
#elif (MAIN_Fosc < 60000000UL)
#define WAIT 0x01
#else
#define WAIT 0x02
#endif

// Զ׷Ƶ
// IRCBANDIRCƵѡ񣩼Ĵֵ
#if (MAIN_Fosc > 35000000UL)
#define BAND 0x02
#elif (MAIN_Fosc > 20000000UL)
#define BAND 0x01
#else
#define BAND 0x00
#endif
#define BAND_MASK 0x03

// CLKDIVĴֵϵͳʱƵ
#if (MAIN_Fosc > 15000000UL)
#define DIV 0x01
#elif (MAIN_Fosc > 12000000UL)
#define DIV 0x02
#elif (MAIN_Fosc > 8000000UL)
#define DIV 0x03
#elif (MAIN_Fosc > 6000000UL)
#define DIV 0x04
#else
#define DIV 0x05
#endif

// ׷ƵĴĿֵ
#define MCLK (MAIN_Fosc * DIV)

#if (MCLK < 50000000UL)
#define CNT ((16 * MCLK) / 32768) // Ƶ
#define CREHF 0x00
#else
#define CNT ((8 * MCLK) / 32768) // Ƶ
#define CREHF 0x08
#endif

#define XRES (CNT * 5 / 1000)


#endif
